File:		
Description:
	test the matlab interface's methods of 
		- executing commands
		- create matrices in matlab (32 and 64 bits integer and double)
		- retrieve the data and save as a matlab_mx_array_s
		- do some calculation in matlab which should results at the end
		  with the same values as originaly retrieved
		- retrive the results and compare to the original retrieved mx_arrays 
		- convert the retrieved results into a sn_matlab_var_s, i.e., 
		  cp the data items from the mx_array to an e list.
		- compare the converted sn_var to the original mx_array. this time using  
		  element wise comparison, i.e., use the get_item() methods of sn_matlab_var_s and
		  of matlab_mx_array_s in order to get each one of the data entries and compare. 
		- put the sn_var's back into matlab, read back and compare one of the sn_var
		  with a mx_arr, using the matlab.is_equal() method.
Notes:
ToDo:
<'
extend sys {
	mx_int : sn_matlab_var_s; //retrieve and save the original matlab data
	mx_dbl : sn_matlab_var_s; //retrieve and save the original matlab data
	mx_int_res : sn_matlab_var_s;//retrieve the results of sin(mx_int)
	mx_dbl_res : sn_matlab_var_s;
		keep all of {
			mx_int.name == "mx_int";  //name is critical to match matlab command
			mx_dbl.name == "mx_dbl";
			mx_int_res.name == "mx_int_res";
			mx_dbl_res.name == "mx_dbl_res";
		};
	---
	!sn_var_int : sn_matlab_var_s;//holds the converted (to specman lists) matlab data. 
	!sn_var_dbl : sn_matlab_var_s;//holds the converted (to specman lists) matlab data. 
	!sn_var_int_res : sn_matlab_var_s;//retrieve the results of sin(sn_var_int)
	!sn_var_dbl_res : sn_matlab_var_s;
	mx_dbl_res_pb : sn_matlab_var_s;
   test_var : sn_matlab_var_s;
-------
	test()@any is {
		var ro : uint;
		var co : uint;
		var idx : uint;
		//check multi dim matrix
		//1.
			//create 3 matrices of size (20,90), i.e., 20 rows each with 90 elements.
			//mx_int : a matrix of random integer numbers between 1..100
			//mx_dbl : a matrix of random double numbers between 0..1
			// Matlab command
		   // "%" is matlab comment

		var sl : list of string = {"mx_int_in = fix(100 * rand(20,90));"; 
		                          "%create a random matrixwith entries in [1..100]"; 
                            	  "%20 rows on 90 colomns"; 
										  "mx_int = int32( mx_int_in );"; 
										  "%convert the matrix to an integer matrix."; 
										  "mx_dbl_in = rand(20,90) ;"; 
        								  "%round to 6 places"; 
										  "mx_dbl = fix(mx_dbl_in * 1000000) * 0.000001;"};
		
		//2. send the above commands to matlab
//		var sl : list of string; 
//		var s2 : list of string; 
		out("2. send commands..");
		MB sl;
		wait [1];
		//3. retrieve the matrix data and save it in specman.
		out("3. retrieve data..");
		compute matlab.get_var(mx_int);  //mx_int is declared as sn_matlab_var_s and it's name is initialized to "mx_int" to match matlab variable name
		compute matlab.get_var(mx_dbl);
		wait [1];
		//4. do some calculations on the original data 
		out("4. do some calculations...");
'>
		sl = <<#:
			sin_res = sin(mx_dbl_in);
			asin_res = asin(sin_res);
				%round to 6 places
			mx_dbl_res = fix(asin_res * 1000000) * 0.000001;
				%create a random integer matrix
			r1 = fix(1000 * rand(20,90));
			t1 = mx_int_in + r1; 
			mx_int_res = int32( t1 - r1 );
		end #;
<'
		var s2 : list of string =
				 {"sin_res = sin(mx_dbl_in);";
				 "asin_res = asin(sin_res);";
				 "mx_dbl_res = fix(asin_res * 1000000) * 0.000001;";
				 "r1 = fix(1000 * rand(20,90));";
				 "t1 = mx_int_in + r1; ";
				 "mx_int_res = int32( t1 - r1 );" };
				 
		MB s2;	//send to matlab.
		//5. retrieve the results into new var's and compare. 
			//5.a retrieve
		wait [1];
		out("5. retrieve data..");
		compute matlab.get_var(mx_int_res);
		compute matlab.get_var(mx_dbl_res);
			//6. compare
		wait [1];
		out("6. comparing ...");
		check that matlab.is_equal_mx(mx_int.mx_arr, mx_int_res.mx_arr); //comparsion done in C, not in e
		check that matlab.is_equal_mx(mx_dbl.mx_arr, mx_dbl_res.mx_arr);
		wait [1];
		out("7. convert to sn_var...");
		sn_var_int 		= matlab.mx_to_sn( mx_int.mx_arr ); //copy to specman and then compare
		sn_var_int_res 	= matlab.mx_to_sn( mx_int_res.mx_arr ); 
		sn_var_dbl 		= matlab.mx_to_sn( mx_dbl.mx_arr ); 
		sn_var_dbl_res 	= matlab.mx_to_sn( mx_dbl_res.mx_arr ); 
		wait [1];
      out("8. do element wise comparison of sn_var and a mx_arr...");
		//comparing e list with mx_array in matlab
		check that compare_sn_var_to_mx_arr_by_item(sn_var_int, mx_int_res.mx_arr ); 
		check that compare_sn_var_to_mx_arr_by_item(sn_var_dbl, mx_dbl_res.mx_arr ); 
		wait [1];
		out("9. put the sn_var's back into matlab...");
		sn_var_int.name			= "sn_var_int"; //specify which variable in matlab to push data into
		sn_var_int_res.name 	= "sn_var_int_res";
		sn_var_dbl.name 		= "sn_var_dbl";
		sn_var_dbl_res.name 	= "sn_var_dbl_res";
		compute matlab.put_var(sn_var_int);
		compute matlab.put_var(sn_var_int_res);
		compute matlab.put_var(sn_var_dbl);
		compute matlab.put_var(sn_var_dbl_res);
		wait [1];
		out("10. read back the sn_var_dbl_res into mx_dbl_res_pb and compare with mx_dbl...");
		mx_dbl_res_pb.name = "sn_var_dbl_res";
	   compute matlab.get_var(mx_dbl_res_pb);
		test_var	= matlab.mx_to_sn( mx_dbl_res_pb.mx_arr ); 
		check that compare_sn_var_to_mx_arr_by_item(sn_var_dbl, mx_dbl_res_pb.mx_arr ); 
		check that matlab.is_equal(sn_var_dbl, mx_dbl_res_pb.mx_arr);
		out("***** finish checking interface *****");
		print session.num_of_dut_errors;
		print session.num_of_dut_warnings;
		wait [1];		 
		stop_run();
	};
	run() is also {
		start test();
		//start matlab and get a pointer to its engine.
		start_matlab();
		out("***** Matlab-Test: use the tick command to move through the stages (10 in total).");
		out("***** Matlab-Test: use:\n\t",
			"'MB deb' 		to turn on the matlab interface debug messages.\n\t",
			"'MB cdeb' 		to turn on the matlab C interface debug messages.\n\t",
			"'MB deb off' 	to turn off the matlab interface debug messages.\n\t",
			"'MB cdeb off' 	to turn off the matlab C interface debug messages.");
		out("	The default for debug messages is off");
	};
	setup() is also { 
		set_config(run, use_manual_tick, TRUE);
	};
	compare_sn_var_to_mx_arr_by_item( sn_var : sn_matlab_var_s, mx_arr : matlab_mx_array_s) : bool is {
		try {
			result = TRUE;
			if(matlab.dbg_flag) {
				out("sys.compare_sn_var_to_mx_arr_by_item(sn_var, mx_arr):\n\t",
					"comparing sn_var with mx_arr.name = '", mx_arr.name, "' element wise.\n\t",
					"mx_arr (rows,cols)=(", mx_arr.rows,",", mx_arr.cols,").\n\t",
					"sn_var number of uint elements = ", sn_var.r_data.size());
			};
			var arr_el : sn_matlab_complex_s;
			var snv_el : sn_matlab_complex_s;
			for ro from 0 to mx_arr.rows - 1 {
				for co from 0 to mx_arr.cols - 1 {
					arr_el = mx_arr.get_item(ro, co);
					snv_el = sn_var.get_item( co * mx_arr.rows + ro);
					check that arr_el.r.low == snv_el.r.low;//check int32 low 32bits
					check that arr_el.r.high == snv_el.r.high;//check int32 low 32bits
				};
			};
		} 
		else {
			result = FALSE;
		};
	};
};
'>
------------------------
-----  CODE END   ------
------------------------
